#!/usr/bin/env python
# -*- coding: iso8859-1 -*-
#
# hello_pass.py: Python bindings for the LLVM compiler infrastructure
# Copyright (c) 2004, 2005 Jarno Seppänen <firstname.lastname@iki.fi>.
# Distributed under the Boost Software License, Version 1.0. (See
# accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)
#

import llvm

class Hello(llvm.FunctionPass):
    def runOnFunction(self, f):
        print "Hello: %s\n" % f.getName()
        return False

#llvm.RegisterOpt(Hello, "hello", "Hello World Pass")

class Hello2(llvm.FunctionPass):
    def runOnFunction(self, f):
        print "Hello: %s\n" % f.getName()
        return False
    
    def getAnalysisUsage(self, au):
        au.setPreservesAll()

#llvm.RegisterOpt(Hello2, "hello2", "Hello World Pass (with getAnalysisUsage implemented)")

h=Hello()
m=llvm.ParseBytecodeFile("hello.ll.bc")
#pm=llvm.PassManager()
#pm.add(h)
#pm.run(m)
h.runOnModule(m)

h=Hello2()
h.runOnModule(m)
